/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */
package com.sun.enterprise.management.base;

import java.util.Set;

import javax.management.Notification;
import javax.management.NotificationListener;
import javax.management.NotificationFilter;
import javax.management.NotificationFilterSupport;

import com.sun.appserv.management.config.Enabled;
import com.sun.appserv.management.base.AMX;

import com.sun.enterprise.management.AMXTestBase;


/**
 */
public final class ListenerTest extends AMXTestBase
{
    public ListenerTest()
    {
    }

    private static class DummyListener implements NotificationListener
    {
        public DummyListener()  {}
        
            public void
        handleNotification(
            final Notification notif,
            final Object handback )
        {
        }
    }
    
	    public void
	testAddRemoveNotificationListener()
	    throws Exception
	{
	    final long  start   = now();
	    final Set<AMX>  all = getAllAMX();
	    
	    final NotificationListener  listener1    = new DummyListener();
	    final NotificationListener  listener2    = new DummyListener();
	    
	    final NotificationFilter    filter  = new NotificationFilterSupport();
	    final Object    handback    = "handback";
	    
	    for( final AMX amx : all )
	    {
	        amx.getNotificationInfo();
	        amx.addNotificationListener( listener1, null, null );
	        amx.addNotificationListener( listener2, filter, handback );
	    }
	    
	    for( final AMX amx : all )
	    {
	        amx.removeNotificationListener( listener1 );
	        amx.removeNotificationListener( listener2, filter, handback );
	    }
	    
	    printElapsed( "Added/removed NotificationListener", all.size(), start );
	}
	
	
 
}


