/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */
package com.sun.enterprise.tools.verifier.tests.ejb;

import com.sun.enterprise.tools.verifier.tests.ejb.EjbTest;
import com.sun.enterprise.deployment.EjbDescriptor;
import com.sun.enterprise.deployment.EjbSessionDescriptor;
import com.sun.enterprise.tools.verifier.tests.ejb.EjbCheck;
import com.sun.enterprise.tools.verifier.*;
import com.sun.enterprise.tools.verifier.tests.*;

/** 
 * The EJB specification does not specify whether the ejb-jar file should 
 * include the classes that are in the ejb-client JAR by copy or by reference. 
 * If the by-copy approach is used, the producer simply includes all the class 
 * files in the ejb-client JAR file also in the ejb-jar file. If the 
 * by-reference approach is used, the ejb-jar file producer does not duplicate 
 * the content of the ejb-client JAR file in the ejb-jar file, but instead uses
 * a Manifest Class-Path entry in the ejb-jar file to specify that the ejb-jar 
 * file depends on the ejb-client JAR at runtime.
 */
public class EjbClientJarManifestClassPath extends EjbTest implements EjbCheck { 




    /** 
     * The EJB specification does not specify whether the ejb-jar file should 
     * include the classes that are in the ejb-client JAR by copy or by reference. 
     * If the by-copy approach is used, the producer simply includes all the class 
     * files in the ejb-client JAR file also in the ejb-jar file. If the 
     * by-reference approach is used, the ejb-jar file producer does not duplicate 
     * the content of the ejb-client JAR file in the ejb-jar file, but instead uses
     * a Manifest Class-Path entry in the ejb-jar file to specify that the ejb-jar 
     * file depends on the ejb-client JAR at runtime.
     *
     * @param descriptor the Enterprise Java Bean deployment descriptor
     *
     * @return <code>Result</code> the results for this assertion
     */
    public Result check(EjbDescriptor descriptor) {

	Result result = getInitializedResult();
	ComponentNameConstructor compName = getVerifierContext().getComponentNameConstructor();

	// Stub test class placeholder
	// fill in guts/logic - pass/fail accordingly in future
	// once DOL returns proper value
	result.setStatus(Result.NOT_IMPLEMENTED);
	result.addNaDetails(smh.getLocalString
			    ("tests.componentNameConstructor",
			     "For [ {0} ]",
			     new Object[] {compName.toString()}));
	result.addNaDetails
	    (smh.getLocalString
	     (getClass().getName() + ".notImplemented",
	      "No static testing done - yet."));
	return result;

    }
}
