/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

/*
 * UuidUtilPadded.java
 *
 * Created on May 26, 2005, 11:15 AM
 */

package com.sun.enterprise.util.uuid;

/**
 *
 * @author  lwhite
 */
public class UuidUtilPadded extends UuidUtil {
    
    static final int DESIRED_UUID_LENGTH = 40;
    
    //this method can take in the session object
    //and insure better uniqueness guarantees
    //needed length must be greater than not less than
    //expected returned lengths - i.e. at least 40
    public static String generateUuid(Object obj, int inputLength) {
        int desiredLength = 
            DESIRED_UUID_LENGTH >= inputLength ? DESIRED_UUID_LENGTH:inputLength;
        String unpaddedUuid = UuidUtil.generateUuid(obj);
        StringBuffer sb = new StringBuffer(unpaddedUuid);
        int neededPadding = desiredLength - unpaddedUuid.length();
        //int neededPadding = DESIRED_UUID_LENGTH - unpaddedUuid.length();
        if(neededPadding > 0) {
            for(int i=0; i<neededPadding; i++) {
                sb.append("F");
            }
        }
        return sb.toString();
    }    
    
    /**
     * Method main
     *
     *
     * @param args
     *
     * @audience
     */
    public static void main(String[] args) {
        System.out.println(UuidUtilPadded.generateUuidMM());
        System.out.println(UuidUtilPadded.generateUuid());
        System.out.println(UuidUtilPadded.generateUuid(new Object()));
        System.out.println(UuidUtilPadded.generateUuid(new Object(), 40));
    }
    
}
